<?php
/*
 +=====================================================================+
 | NinjaFirewall (WP+ Edition)                                         |
 |                                                                     |
 | (c) NinTechNet - https://nintechnet.com/                            |
 +=====================================================================+
*/

if (! isset( $nfw_['nfw_options']['enabled']) && ! defined( 'NFW_STATUS' ) ) {
	header('HTTP/1.1 404 Not Found');
	header('Status: 404 Not Found');
	exit;
}
// =====================================================================

$gateways_ip = [
	'paypal_ipn' => [
		'64.4.240.0/21',
		'64.4.248.0/22',
		'66.211.168.0/22',
		'91.243.72.0/23',
		'173.0.80.0/20',
		'185.177.52.0/22',
		'192.160.215.0/24',
		'198.54.216.0/23'
	],
	'stripes_webhook' => [
		'3.18.12.63',
		'3.130.192.231',
		'13.235.14.237',
		'13.235.122.149',
		'18.211.135.69',
		'35.154.171.200',
		'52.15.183.38',
		'54.88.130.119',
		'54.88.130.237',
		'54.187.174.169',
		'54.187.205.235',
		'54.187.216.72'
	],
	'jetpack_ipv4' => [
		'122.248.245.244/32',
		'54.217.201.243/32',
		'54.232.116.4/32',
		'192.0.80.0/20',
		'192.0.96.0/20',
		'192.0.112.0/20',
		'195.234.108.0/22'
	]
];
$gateways_info = [
	'paypal_ipn' => [
		'name' => 'PayPal IPN (notify.paypal.com)',
		'url' => 'https://www.paypal.com/au/smarthelp/article/what-are-the-ip-addresses-for-live-paypal-servers-ts1056'
	],
	'stripes_webhook' => [
		'name' => 'Stripes (webhook notifications)',
		'url' => 'https://stripe.com/docs/ips'
	],
	'jetpack_ipv4' => [
		'name' => 'Automattic (JetPack, VaultPress etc)',
		'url' => 'https://jetpack.com/support/hosting-faq/#jetpack-whitelist',
		'url' => 'https://help.vaultpress.com/connection-issues/'
	]
];

// =====================================================================
// EOF
